/*$Id: udf_str.sql,v 0.2 2000/07/11 07:39:25 frank Exp $*/
/* Converts the input string to upper case using an ISO8859_1 translation
   table */
DECLARE EXTERNAL FUNCTION str_upper
        cstring(254)
        RETURNS cstring(254)
        ENTRY_POINT 'str_upper' MODULE_NAME 'libfpc_udf_str.so';

/* Converts the input string to lower case using an ISO8859_1 translation
   table */
DECLARE EXTERNAL FUNCTION str_lower
        cstring(254)
        RETURNS cstring(254)
        ENTRY_POINT 'str_lower' MODULE_NAME 'libfpc_udf_str.so';

/* returns the input string in reverse order 
   so str_reverse('esabretnI') will return Interbase */
DECLARE EXTERNAL FUNCTION str_reverse
        cstring(254)
        RETURNS cstring(254)
        ENTRY_POINT 'str_reverse' MODULE_NAME 'libfpc_udf_str.so';

/* concatenates the two input strings, null values are
   handled as empty strings  */ 
DECLARE EXTERNAL FUNCTION str_cat
        cstring(254),cstring(254),cstring(512)
        RETURNS PARAMETER 3
        ENTRY_POINT 'str_cat' MODULE_NAME 'libfpc_udf_str.so';

/* returns the remaining part of input string 1 after first occurence of
   input string 2 so
   str_chop_left('schlottmann-goedde@t-online,de','@') will return
   'schlottmann-goedde' */
DECLARE EXTERNAL FUNCTION str_chop_left
        cstring(254),cstring(254),cstring(256)
        RETURNS PARAMETER 3
        ENTRY_POINT 'str_chop_left' MODULE_NAME 'libfpc_udf_str.so';

/* returns input string 1 up to last occurence of
   input string 2 so
   str_chop_right('schlottmann-goedde@t-online,de','@') will return
   't-online.de' */
DECLARE EXTERNAL FUNCTION str_chop_right
        cstring(254),cstring(254),cstring(512)
        RETURNS PARAMETER 3
        ENTRY_POINT 'str_chop_right' MODULE_NAME 'libfpc_udf_str.so';

/* will trim input string depending on first input value
   -1: remove leading blanks and nonprintable chars
    1: remove trailing blanks and nonprintable chars
    0: do both
    any other value: do nothing */
DECLARE EXTERNAL FUNCTION str_trim
        integer,cstring(254),cstring(254)
        RETURNS PARAMETER 3
        ENTRY_POINT 'str_trim' MODULE_NAME 'libfpc_udf_str.so';

/* will return substring 
    str_substr('01234567890',2,6) will return '23456'
    If starting value is greater than length of string
    do nothing */
DECLARE EXTERNAL FUNCTION str_substr
        cstring(254),integer,integer,cstring(254)
        RETURNS PARAMETER 4
        ENTRY_POINT 'str_substr' MODULE_NAME 'libfpc_udf_str.so';

/* returns the actual length of input string */
DECLARE EXTERNAL FUNCTION str_len
        varchar(254)
        RETURNS integer by value
        ENTRY_POINT 'str_len' MODULE_NAME 'libfpc_udf_str.so';
