{ 
$Id: fpc_udf_dt.pp,v 0.1 2000/07/11 07:36:07 frank Exp $
(C)2000 Frank Schlottmann-Goedde
time/date handling
user defined functions (UDF)
for Interbase 6.0 SS for Linux
use at your own risc
}

library fpc_udf_dt;
{$mode objfpc}
{$PACKRECORDS C}

uses strings;

{$linklib gds}  {I only need isc_decode_date at the moment}

type

 isc_quad= record
             low:longint;
             high:dword;
            end;

 pisc_quad=^isc_quad;
  
 Tm = record
     tm_sec : longint;   // Seconds
     tm_min : longint;   // Minutes
     tm_hour : longint;  // Hour (0--23)
     tm_mday : longint;  // Day of month (1--31)
     tm_mon : longint;   // Month (0--11)
     tm_year : longint;  // Year (calendar year minus 1900)
     tm_wday : longint;  // Weekday (0--6) Sunday = 0)
     tm_yday : longint;  // Day of year (0--365)
     tm_isdst : longint; // 0 if daylight savings time is not in effect)
     tm_gmtoff: longint;
  end;
  
procedure isc_decode_date(_para1:PISC_QUAD; _para2:pointer); cdecl; external;  

procedure init_tm(var tm_date:Tm);
begin
  with tm_date do 
  begin
   tm_sec    := 0;
   tm_min    := 0;
   tm_hour   := 0;
   tm_mday   := 0;
   tm_mon    := 0;
   tm_year   := 0;
   tm_wday   := 0;
   tm_yday   := 0;
   tm_isdst  := 0;
   tm_gmtoff{.low} := 0;
 {  tm_gmtoff.high:= 0; } 
  end;
end;

function dt_Month(ib_date: PISC_QUAD): longint;export;
var
  tm_date:Tm;
begin
  init_tm(tm_date);
  isc_decode_date(ib_date,@tm_date);
  result :=tm_date.tm_mon+1;
end;

function dt_Day(ib_date: PISC_QUAD): longint;export;
var
  tm_date:Tm;
begin
  init_tm(tm_date);
  isc_decode_date(ib_date,@tm_date);
  result :=tm_date.tm_mday;
end;

function dt_Year(ib_date: PISC_QUAD): longint;export;
var
  tm_date:Tm;
begin
  init_tm(tm_date);
  isc_decode_date(ib_date,@tm_date);
  result :=tm_date.tm_year+1900;
end;
  
  
  
exports
 dt_year    name 'dt_year',
 dt_day    name 'dt_day',
 dt_month  name 'dt_month';
end.